/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TInputWebform.TInputWebformPath;
import de.ship.db.tables.records.TInputReferenceRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputReference extends TableImpl<TInputReferenceRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_reference</code>
     */
    public static final TInputReference T_INPUT_REFERENCE = new TInputReference();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputReferenceRecord> getRecordType() {
        return TInputReferenceRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_reference.lastchange</code>.
     */
    public final TableField<TInputReferenceRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_reference.reference_id</code>.
     */
    public final TableField<TInputReferenceRecord, String> REFERENCE_ID = createField(DSL.name("reference_id"), SQLDataType.CLOB.nullable(false), this, "");

    private TInputReference(Name alias, Table<TInputReferenceRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputReference(Name alias, Table<TInputReferenceRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_reference</code> table
     * reference
     */
    public TInputReference(String alias) {
        this(DSL.name(alias), T_INPUT_REFERENCE);
    }

    /**
     * Create an aliased <code>common_dd.t_input_reference</code> table
     * reference
     */
    public TInputReference(Name alias) {
        this(alias, T_INPUT_REFERENCE);
    }

    /**
     * Create a <code>common_dd.t_input_reference</code> table reference
     */
    public TInputReference() {
        this(DSL.name("t_input_reference"), null);
    }

    public <O extends Record> TInputReference(Table<O> path, ForeignKey<O, TInputReferenceRecord> childPath, InverseForeignKey<O, TInputReferenceRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_REFERENCE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputReferencePath extends TInputReference implements Path<TInputReferenceRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputReferencePath(Table<O> path, ForeignKey<O, TInputReferenceRecord> childPath, InverseForeignKey<O, TInputReferenceRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputReferencePath(Name alias, Table<TInputReferenceRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputReferencePath as(String alias) {
            return new TInputReferencePath(DSL.name(alias), this);
        }

        @Override
        public TInputReferencePath as(Name alias) {
            return new TInputReferencePath(alias, this);
        }

        @Override
        public TInputReferencePath as(Table<?> alias) {
            return new TInputReferencePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public UniqueKey<TInputReferenceRecord> getPrimaryKey() {
        return Keys.PK_INPUT_REFERENCE;
    }

    private transient TInputWebformPath _tInputWebform;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_input_webform</code> table
     */
    public TInputWebformPath tInputWebform() {
        if (_tInputWebform == null)
            _tInputWebform = new TInputWebformPath(this, null, Keys.T_INPUT_WEBFORM__FK_WEBFORM_REFERENCE.getInverseKey());

        return _tInputWebform;
    }

    @Override
    public TInputReference as(String alias) {
        return new TInputReference(DSL.name(alias), this);
    }

    @Override
    public TInputReference as(Name alias) {
        return new TInputReference(alias, this);
    }

    @Override
    public TInputReference as(Table<?> alias) {
        return new TInputReference(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputReference rename(String name) {
        return new TInputReference(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputReference rename(Name name) {
        return new TInputReference(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputReference rename(Table<?> name) {
        return new TInputReference(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference where(Condition condition) {
        return new TInputReference(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputReference where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputReference where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputReference where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputReference where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputReference whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
